(
Global rolloutUVPuppy
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local iniFile = ((getFilenamePath (getThisScriptFilename())) + "UVPuppy_Settings.ini")
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_GetINIExecute ini SectionStr KeyStr def = (if (hasINISetting ini SectionStr KeyStr) then (execute (getINISetting ini SectionStr KeyStr)) else (return def))
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_GetINIExecuteStr ini SectionStr KeyStr defSrt = (if (hasINISetting ini SectionStr KeyStr) then (getINISetting ini SectionStr KeyStr) else (return defSrt))
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local roll0W = 155; local roll0H = 604   ---624 maximum
local y1 = 94
local colCHBX = fn_GetINIExecute iniFile "General" "CheckboxColor" [255,156,0]
local colCHBXgray = gray
----=========================================================================================================================================================================================================
rollout rolloutUVPuppy "UV Puppy"
(
button btn_DockLeft "<" pos:[133,10] width:14 height:14 tooltip:"Dock Left"
button btn_DockRight ">" pos:[133,26] width:14 height:14 tooltip:"Dock Right"
groupBox grp_Process "" pos:[6,2] width:144 height:294
radiobuttons rdbtn_FromObjcts "" labels:#("Selected","Scene") pos:[12,13] columns:2 default:(fn_GetINIExecute iniFile "General" "InputArray" 1) tooltip:"Process Objects from ..."
-- checkbox chbx_WeldInProcess " Weld" pos:[14,34] checked:(fn_GetINIExecute iniFile "General" "WeldInProcess" true) tooltip:"Weld All Vertices"
checkButton chbtn_WeldInProcess pos:[14,34] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "WeldInProcess" false) enabled:true highlightColor:colCHBXgray tooltip:"Weld All Vertices"
label lbl_WeldInProcess "Weld" pos:[32,35]
spinner spnr_WeldThresholdInProcess "" pos:[64,34] width:62 range:[0.001,9999,(fn_GetINIExecute iniFile "General" "WeldThresholdInProcess" 0.001)] type:#Float scale:0.001 enabled:(chbtn_WeldInProcess.checked) tooltip:"Set Channel"
-- checkbox chbx_ChToCh " Channel" pos:[14,50] checked:(fn_GetINIExecute iniFile "General" "ChanelToChanel" true) tooltip:"UV From Chanel 1 to Chanel 2 and Pack"
checkButton chbtn_ChToCh pos:[14,50] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "ChanelToChanel" false) enabled:true highlightColor:colCHBXgray tooltip:"UV From Chanel 1 to New Chanel and Pack"
label lbl_ChToCh "Channel" pos:[32,51]
spinner spnr_ToChannel "" pos:[80,50] width:64 range:[0,99,(fn_GetINIExecute iniFile "General" "ToChannel" 1)] type:#Integer scale:1 enabled:(chbtn_ChToCh.checked) tooltip:"Set Channel"
radiobuttons rdbtn_ByObjMat "" labels:#("Object","Material") pos:[14,66] columns:2 default:(fn_GetINIExecute iniFile "General" "ProcessBy" 1) enabled:(chbtn_ChToCh.checked) tooltip:"Process by ..."
-- checkbox chbx_Pack " Pack" pos:[14,82] checked:(fn_GetINIExecute iniFile "General" "Pack" true) enabled:(chbtn_ChToCh.checked) tooltip:"Pack"
checkButton chbtn_Pack pos:[14,82] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "Pack" false) enabled:(chbtn_ChToCh.checked) highlightColor:colCHBXgray tooltip:"Pack"
label lbl_Pack "Pack" pos:[32,83] enabled:(chbtn_ChToCh.checked)
groupBox grp_Pack "" pos:[13,(y1)] width:130 height:120
dropdownlist ddl_Algorithm items:(#("Recursive Packing","Linear Packing","Non-Convex")) pos:[18,(y1+10)] width:120 height:4 selection:(fn_GetINIExecute iniFile "PackSettings" "Algorithm" 3) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"Packing Algorithm \n Linear packing algorithm fast \n but not that efficient. \n Recursive algorithm slower \n but more efficient"
spinner spnr_Padding "Padding" pos:[18,(y1+33)] width:120 range:[0.,1.,(fn_GetINIExecute iniFile "PackSettings" "Padding" 0.005)] type:#Float scale:0.001 enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"The gap between cluster in percentage\nof the edge distance of the square"
-- checkbox chbx_NormalizeClstrs " Normalize Clusters" pos:[22,(y1+49)] checked:(fn_GetINIExecute iniFile "PackSettings" "NormalizeClusters" true) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"Determines whether the clusters\nwill be fit to 0 to 1 space"
checkButton chbtn_NormalizeClstrs pos:[21,(y1+49)] width:14 height:14 checked:(fn_GetINIExecute iniFile "PackSettings" "NormalizeClusters" false) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) highlightColor:colCHBXgray tooltip:"Determines whether the clusters\nwill be fit to 0 to 1 space"
label lbl_NormalizeClstrs "Normalize Clusters" pos:[39,(y1+50)] enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked)
-- checkbox chbx_RotateClstrs " Rotate Clusters" pos:[22,(y1+65)] checked:(fn_GetINIExecute iniFile "PackSettings" "RotateClusters" true) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"Determines whether a cluster will be rotated so it takes up less space"
checkButton chbtn_RotateClstrs pos:[21,(y1+65)] width:14 height:14 checked:(fn_GetINIExecute iniFile "PackSettings" "RotateClusters" false) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) highlightColor:colCHBXgray tooltip:"Determines whether a cluster will be rotated so it takes up less space"
label lbl_RotateClstrs "Rotate Clusters" pos:[39,(y1+66)] enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked)
-- checkbox chbx_FillHoles " Fill Holes" pos:[22,(y1+81)] checked:(fn_GetINIExecute iniFile "PackSettings" "FillHoles" true) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"Determines whether smaller clusters will be put in the holes of the larger cluster"
checkButton chbtn_FillHoles pos:[21,(y1+81)] width:14 height:14 checked:(fn_GetINIExecute iniFile "PackSettings" "FillHoles" false) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) highlightColor:colCHBXgray tooltip:"Determines whether smaller clusters will be put in the holes of the larger cluster"
label lbl_FillHoles "Fill Holes" pos:[39,(y1+82)] enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked)
-- checkbox chbx_RescaleClusters " Rescale Clusters" pos:[22,(y1+97)] checked:(fn_GetINIExecute iniFile "PackSettings" "RescaleClusters" true) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) tooltip:"Rescale Clusters"
checkButton chbtn_RescaleClusters pos:[21,(y1+97)] width:14 height:14 checked:(fn_GetINIExecute iniFile "PackSettings" "RescaleClusters" false) enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked) highlightColor:colCHBXgray tooltip:"Rescale Clusters"
label lbl_RescaleClusters "Rescale Clusters" pos:[39,(y1+98)] enabled:(chbtn_ChToCh.checked and chbtn_Pack.checked)
-- checkbox chbx_PivotCenter " Pivot to Center" pos:[14,217] checked:(fn_GetINIExecute iniFile "General" "PivotToCenter" true) tooltip:"Pivot in the center of the object"
checkButton chbtn_PivotCenter pos:[14,217] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "PivotToCenter" false) highlightColor:colCHBXgray tooltip:"Pivot in the center of the object"
label lbl_PivotCenter "Pivot to Center" pos:[32,218]
-- checkbox chbx_PivotZmin " Z" pos:[113,217] checked:(fn_GetINIExecute iniFile "General" "PivotToZmin" true) tooltip:"Pivot to the minimum of the object Z axis"
checkButton chbtn_PivotZmin pos:[113,217] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "PivotToZmin" false) highlightColor:colCHBXgray tooltip:"Pivot to the minimum of the object Z axis"
label lbl_PivotZmin "Z" pos:[131,218]
-- checkbox chbx_ResetXForm " Reset XForm" pos:[14,233] checked:(fn_GetINIExecute iniFile "General" "ResetXForm" true) tooltip:"Reset XForm and Convert to Editable Poly"
checkButton chbtn_ResetXForm pos:[14,233] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "ResetXForm" false) highlightColor:colCHBXgray tooltip:"Reset XForm and Convert to Editable Poly"
label lbl_ResetXForm "Reset XForm" pos:[32,234]
-- checkbox chbx_AttachColorState "" pos:[102,234] checked:(fn_GetINIExecute iniFile "General" "AttachColorState" true) tooltip:"Set Process and Attach Objects Wire Color"
checkButton chbtn_AttachColorState pos:[108,234] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "AttachColorState" false) highlightColor:colCHBXgray tooltip:"Set Process and Attach Objects Wire Color"
-- label lbl_AttachColorState "" pos:[131,218]
colorpicker color_AttachWireColor "" pos:[120,232] width:22 height:18 color:(fn_GetINIExecute iniFile "General" "AttachWireColor" [255,156,0]) modal:false tooltip:"Processed and Attached Objects Wire Color"
button btn_Process "Process" pos:[14,252] width:128 height:24 tooltip:"Lmb - Process Objects\nRmb - Process and Open Unwrap"
progressBar prgrs_Process pos:[12,280] width:131 height:10 value:0 color:orange

button btn_ResetXForm "Reset XForm" pos:[6,300] width:71 height:18 tooltip:"Reset XForm and Convert to Editable Poly"
button btn_ConvertToEP "Editable Poly" pos:[78,300] width:71 height:18 tooltip:"Convert to Editable Poly"
button btn_AddNormal "Normal" pos:[6,320] width:40 height:18 tooltip:"Lmb - Add Normal Modifier\nRmb - Add Unique Normal Modifier"
button btn_FlipNormals "Flip" pos:[47,320] width:24 height:18 tooltip:"Lmb - Flip Normals\nRmb - Smart Flip Normals"
button btn_Weld "Weld" pos:[72,320] width:30 height:18 tooltip:"Weld"
spinner spnr_WeldThreshold "" pos:[102,322] width:47 range:[0.001,9999,(fn_GetINIExecute iniFile "General" "WeldThreshold" 0.001)] type:#Float scale:0.001 tooltip:"WeldThreshold"
button btn_SelInstances "Instances" pos:[6,340] width:71 height:18 tooltip:"Select Objects Instances"
button btn_MakeUnique "Make Unique" pos:[78,340] width:71 height:18 tooltip:"Make Objects Unique"
button btn_SelByMaterial "Material" pos:[6,360] width:49 height:18 tooltip:"Lmb - Select Objects by Material\nRmb - Select Objects by Material,\n          Include Hiden Objects"
button btn_SelByWire "Wire Color" pos:[56,360] width:59 height:18 tooltip:"Lmb - Select Objects by Wire Color\nRmb - Select Objects by Wire Color,\n          Include Hiden Objects"
button btn_SelByMultiSub "Multi" pos:[116,360] width:33 height:18 tooltip:"Lmb - Select by Multi/Sub-Object Material\nRmb - Select by Multi/Sub-Object Material,\n          Include Hiden Objects"
button btn_Attach "Attach" pos:[6,380] width:54 height:18 tooltip:"Lmb - Attach Objects\nRmb - Attach Objects by Material"
spinner spnr_AttachParts "" pos:[60,382] width:40 range:[1,999,(fn_GetINIExecute iniFile "General" "AttachParts" 1)] type:#Integer scale:1 tooltip:"Attach Parts"
button btn_Detach "Detach" pos:[101,380] width:48 height:18 tooltip:"Lmb - Detach Element as Object\nRmb - Detach Element with Dialog"
button btn_Explode "Explode" pos:[6,400] width:54 height:18 tooltip:"     Lmb - Explode Objects to Elements\nAlt+Lmb - Explode to Elements (Set Name)\n     Rmb - Explode Objects by ID\nAlt+Rmb - Explode by ID (Set Name)"
spinner spnr_ExplodeParts "" pos:[60,402] width:40 range:[0,999,(fn_GetINIExecute iniFile "General" "ExplodeParts" 0)] type:#Integer scale:1 tooltip:"Explode Parts"
button btn_SetWireColor "Set" pos:[101,400] width:30 height:18 tooltip:"Set Objects Wire Color"
colorpicker color_SetWireColor "" pos:[127,400] width:22 height:18 color:(fn_GetINIExecute iniFile "General" "SetWireColor" [255,156,0]) modal:false tooltip:"Set Objects Wire Color"
button btn_PivotToCenter "Pivot To Center" pos:[6,420] width:84 height:18 tooltip:"Pivot in the center of the object"
button btn_PivotToZmin "Z Minimum" pos:[91,420] width:58 height:18 tooltip:"Pivot to the minimum of the object Z axis"
button btn_AddUnwrapUVW "Unwrap UVW" pos:[6,440] width:71 height:18 tooltip:"Lmb - Add Unwrap UVW\nRmb - Open(Add) Unwrap UVW"
spinner spnr_AddUnwrapChannel "" pos:[77,442] width:34 range:[1,99,(fn_GetINIExecute iniFile "General" "AddUnwrapChannel" 1)] type:#Integer scale:1 tooltip:"Unwrap Channel"
button btn_UnwrapUVWCheck "Check" pos:[112,440] width:37 height:18 tooltip:"Lmb - Add Check Unwrap UVW\nRmb - Delete Check Unwrap UVW"
button btn_FlattenMapping "Flatten" pos:[6,460] width:45 height:18 tooltip:"Flatten Mapping"
spinner spnr_FlattenAngleThreshold "" pos:[51,462] width:49 range:[0,180,(fn_GetINIExecute iniFile "General" "FlattenAngleThreshold" 45.0)] type:#Float scale:0.1 tooltip:"Polygon Angle Threshold"
spinner spnr_FlattenSpacing "" pos:[100,462] width:49 range:[0,1,(fn_GetINIExecute iniFile "General" "FlattenSpacing" 0.005)] type:#Float scale:0.001 tooltip:"Flatten Spacing"
button btn_AddUVWMap "UVW Map" pos:[6,480] width:53 height:18 tooltip:"Lmb - Add UVW Map Modifier\nRmb - Add Unique UVW Map Modifier"
spinner spnr_UVWMapSize "" pos:[59,482] width:45 range:[0,9999,(fn_GetINIExecute iniFile "General" "UVWMapSize" 100)] type:#Float scale:0.1 tooltip:"UVW Map Size"
button btn_AddSmooth "Smooth" pos:[105,480] width:44 height:18 tooltip:"Lmb - Add Smooth Modifier\nRmb - Add Unique Smooth Modifier"
button btn_ExportFBX "Export FBX" pos:[6,500] width:63 height:18 tooltip:"Lmb - Export Selection as FBX\nRmb - Export Selection as FBX with Dialog"
button btn_AddEditPoly "Edit Poly" pos:[70,500] width:52 height:18 tooltip:"Lmb - Add Edit Poly Modifier\nRmb - Add Unique Edit Poly Modifier"
button btn_AddTurboSmooth "TS" pos:[123,500] width:26 height:18 tooltip:"Lmb - Add Turbo Smooth Modifier\nRmb - Add Turbo Smooth Modifier,\n          by Smoothing Groups"
button btn_GroupGroup "Group" pos:[6,520] width:48 height:18 tooltip:"Lmb - Fast Group\nRmb - Group with Dialog"
button btn_UngroupGroup "Ungroup" pos:[55,520] width:52 height:18 tooltip:"Lmb - Ungroup\nRmb - Explode Groups"
button btn_OpenGroup "Open" pos:[109,520] width:40 height:18 tooltip:"Lmb - Open Group\nRmb - Close Group"
edittext edt_NewName "" text:"" pos:[4,540] width:143 height:17 enabled:true
-- checkbox chbx_RenameAddCounter "Counter" pos:[6,562] checked:(fn_GetINIExecute iniFile "General" "RenameAddCounter" true) tooltip:"Add Counter"
checkButton chbtn_RenameAddCounter pos:[7,562] width:14 height:14 checked:(fn_GetINIExecute iniFile "General" "RenameAddCounter" false) highlightColor:colCHBXgray tooltip:"Add Counter"
label lbl_RenameAddCounter "Counter" pos:[25,562]
button btn_GetName "Get" pos:[68,560] width:26 height:18 tooltip:"Lmb - Get Name from Object\nRmb - Get Name from Material"
button btn_Rename "Rename" pos:[95,560] width:53 height:18 tooltip:"Lmb - Rename Selected Objects\nRmb - Names Repair for Selection"
button btn_Quadrify "Quadrify" pos:[6,580] width:143 height:18 tooltip:"Quadrify Objects"
-- button btn_SmoothingGroupsByUV "Smoothing by UV Shells" pos:[6,600] width:143 height:18 tooltip:"Smoothing Groups by UV Shells (TexTools)"
-- button btn_WeightedNormals "Weighted Normals" pos:[6,620] width:143 height:18 tooltip:"Weighted Normals (by Martijn Buijs)"

-----ControlArrays------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local CHBXarr = #(chbtn_WeldInProcess,chbtn_ChToCh,chbtn_Pack,chbtn_NormalizeClstrs,chbtn_RotateClstrs,chbtn_FillHoles,chbtn_RescaleClusters,chbtn_PivotCenter,chbtn_PivotZmin,chbtn_ResetXForm,chbtn_AttachColorState,chbtn_RenameAddCounter)
-----ControlArrays------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_setCHBXcol CHBXarr = 
(
local rgbCol; local pickCol = colorPickerDlg colCHBX "Pick Checkbox Color:"
if pickCol != undefined
-- then (rgbCol = [pickCol.r,pickCol.g,pickCol.b]; for cntrl in CHBXarr do (cntrl.highlightColor = rgbCol; SetFocus cntrl))
then (rgbCol = [pickCol.r,pickCol.g,pickCol.b]; for cntrl in CHBXarr do (if cntrl.enabled then cntrl.highlightColor = rgbCol else cntrl.highlightColor = colCHBXgray; SetFocus cntrl))
else (rgbCol = colCHBX)
SetFocus rolloutUVPuppy
return rgbCol
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_updateCHBXcol CHBXarr =
(
for cntrl in CHBXarr do
	(
	if cntrl.enabled
	then (cntrl.highlightColor = colCHBX)
	else (cntrl.highlightColor = colCHBXgray)
	SetFocus cntrl
	)
SetFocus rolloutUVPuppy
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_compareNames objct1 objct2 = stricmp objct1.name objct2.name
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_ArraysDifference arrA arrB = (for objct in arrA where findItem arrB objct == 0 collect objct)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_InstancesTrim objctsArr = (local TrimArr = #(); for objct in objctsArr do (local objState = false; for trobj in TrimArr do (if (areNodesInstances trobj objct) then objState = true); if not objState then (appendIfUnique TrimArr objct)); return TrimArr)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_GetObjs = 
(
if rdbtn_FromObjcts.state == 1
then (for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject) and (IsValidNode objct)) collect objct)
else (for objct in objects where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject) and (IsValidNode objct)) collect objct)
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- FN fn_RemoveCounter nm =
-- (
-- local NumStrArr = #("1","2","3","4","5","6","7","8","9","0")
-- while (findItem NumStrArr nm[nm.count] != 0) do (nm = replace nm (nm.count) 1 "")
-- if (nm[nm.count] != "_") then (nm += "_")
-- return nm
-- )
FN fn_RemoveCounter nm =
(
local NumStrArr = #("1","2","3","4","5","6","7","8","9","0")
while (findItem NumStrArr nm[nm.count] != 0) do (nm = replace nm (nm.count) 1 "")
if (nm[nm.count] == "_") then (nm = replace nm (nm.count) 1 "")
return nm
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_RenameAddCounter NewName ObjectsArray Separator CounterDigits = (for objct in ObjectsArray do (objct.name = uniqueName "AbrAbrvalg" numDigits:9); for objct in ObjectsArray do (objct.name = uniqueName (NewName + Separator) numDigits:(if CounterDigits == 0 then (ObjectsArray.count as string).count else CounterDigits)))
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_toEMtoEPnoSubSel inArr = (ConvertTo inArr Editable_Mesh; ConvertTo inArr Editable_Poly; for objct in inArr do (objct.SetSelection #Vertex #{}; objct.SetSelection #Edge #{}; objct.SetSelection #Face #{}))
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_SmartFlipNormal GeometryArray =
(
ConvertTo GeometryArray Editable_Mesh
for obj in GeometryArray do
(
----------------- getElements
local elementsArr=#(); local facesDoneArr=#(); local facesArr=#()
for fi=1 to obj.numfaces do (if (finditem facesDoneArr fi) == 0 then (facesArr = meshop.getElementsUsingFace obj #(fi); append elementsArr facesArr; join facesDoneArr facesArr))
----------------- smartFlip
for elSel in elementsArr do
	(
	local vertSel = meshop.getVertsUsingFace obj elSel
	local c = [0.0,0.0,0.0]
	for vIndx in vertSel do (v = getVert obj vIndx; c += v)
	c /= vertSel.count
	local d = 0.0
	for fIndx in elSel do (n1 = getFaceNormal obj fIndx; verts = getface obj fIndx; v1 = getVert obj verts.x; v2 = getVert obj verts.y; v3 = getVert obj verts.z; v = (v1 + v2 + v3) / 3; n2 = normalize(c - v); d += (dot n1 n2))
	d /= elSel.count
	if (d > 0.0) then (meshop.flipNormals obj elSel)
	)
)
ConvertTo GeometryArray Editable_Poly
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_Weld objArr Threshold =
(
for objct in objArr do
	(
	objct.EditablePoly.SetSelection #Vertex #{1..(objct.verts.count)}
	objct.weldThreshold = Threshold
	objct.EditablePoly.weldFlaggedVertices ()
	objct.EditablePoly.SetSelection #Vertex #{}
	)
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_Attach objArr = 
(
for n in objArr.count to 2 by -1 do (polyop.attach objArr[1] objArr[n])
local objName = fn_RemoveCounter objArr[1].name
-- objArr[1].name = uniqueName objName numDigits:3
fn_RenameAddCounter objName #(objArr[1]) "_" 3
return objArr[1]
)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_Warning1 = (messageBox "Objects are not Selected or the Scene is Empty." title:" WARNING !!!" beep:false)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
FN fn_Warning2 = (messageBox "Objects are not Selected or Objects is not a Geometry." title:" WARNING !!!" beep:false)
-----fn---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
on btn_DockLeft pressed do
(
if rolloutUVPuppy.dialogBar == false
then
	(
	try (setINISetting iniFile "DialogPosition" "LastPosition" ((GetDialogPos rolloutUVPuppy) as string)) catch()
	cui.RegisterDialogBar rolloutUVPuppy style:#(#cui_dock_vert)
	cui.DockDialogBar rolloutUVPuppy #cui_dock_left
	)
else
	(
	if cui.getDockState rolloutUVPuppy == #cui_dock_right
	then
		(
		cui.DockDialogBar rolloutUVPuppy #cui_dock_left
		)
	else
		(
		cui.UnRegisterDialogBar rolloutUVPuppy
		SetDialogPos rolloutUVPuppy (fn_GetINIExecute iniFile "DialogPosition" "LastPosition" [5,30])
		rolloutUVPuppy.width = roll0W
		rolloutUVPuppy.height = roll0H
		)
	)
setINISetting iniFile "DialogPosition" "DockState" ((try (cui.getDockState rolloutUVPuppy) catch(undefined)) as string)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_DockRight pressed do
(
if rolloutUVPuppy.dialogBar == false
then
	(
	try (setINISetting iniFile "DialogPosition" "LastPosition" ((GetDialogPos rolloutUVPuppy) as string)) catch()
	cui.RegisterDialogBar rolloutUVPuppy style:#(#cui_dock_vert)
	cui.DockDialogBar rolloutUVPuppy #cui_dock_right
	)
else
	(
	if cui.getDockState rolloutUVPuppy == #cui_dock_left
	then
		(
		cui.DockDialogBar rolloutUVPuppy #cui_dock_right
		)
	else
		(
		cui.UnRegisterDialogBar rolloutUVPuppy
		SetDialogPos rolloutUVPuppy (fn_GetINIExecute iniFile "DialogPosition" "LastPosition" [5,30])
		rolloutUVPuppy.width = roll0W
		rolloutUVPuppy.height = roll0H
		)
	)
setINISetting iniFile "DialogPosition" "DockState" ((try (cui.getDockState rolloutUVPuppy) catch(undefined)) as string)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_WeldInProcess changed state do (spnr_WeldThresholdInProcess.enabled = state; SetFocus rolloutUVPuppy)
on chbtn_WeldInProcess rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_ChToCh changed state do 
(
spnr_ToChannel.enabled = rdbtn_ByObjMat.enabled = chbtn_Pack.enabled = lbl_Pack.enabled = state
if chbtn_Pack.checked
then (ddl_Algorithm.enabled = spnr_Padding.enabled = chbtn_NormalizeClstrs.enabled = lbl_NormalizeClstrs.enabled = chbtn_RotateClstrs.enabled = lbl_RotateClstrs.enabled = chbtn_FillHoles.enabled = lbl_FillHoles.enabled = chbtn_RescaleClusters.enabled = lbl_RescaleClusters.enabled = state)
fn_updateCHBXcol CHBXarr
)
on chbtn_ChToCh rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_Pack changed state do 
(
ddl_Algorithm.enabled = spnr_Padding.enabled = chbtn_NormalizeClstrs.enabled = lbl_NormalizeClstrs.enabled = chbtn_RotateClstrs.enabled = lbl_RotateClstrs.enabled = chbtn_FillHoles.enabled = lbl_FillHoles.enabled = chbtn_RescaleClusters.enabled = lbl_RescaleClusters.enabled = state
fn_updateCHBXcol CHBXarr
)
on chbtn_Pack rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_NormalizeClstrs changed state do (SetFocus rolloutUVPuppy)
on chbtn_NormalizeClstrs rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_RotateClstrs changed state do (SetFocus rolloutUVPuppy)
on chbtn_RotateClstrs rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_FillHoles changed state do (SetFocus rolloutUVPuppy)
on chbtn_FillHoles rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_RescaleClusters changed state do (SetFocus rolloutUVPuppy)
on chbtn_RescaleClusters rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_PivotCenter changed state do (SetFocus rolloutUVPuppy)
on chbtn_PivotCenter rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_PivotZmin changed state do (SetFocus rolloutUVPuppy)
on chbtn_PivotZmin rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_ResetXForm changed state do (SetFocus rolloutUVPuppy)
on chbtn_ResetXForm rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_AttachColorState changed state do (SetFocus rolloutUVPuppy)
on chbtn_AttachColorState rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Process pressed do
with undo on
(
max create mode
prgrs_Process.value = 0
prgrs_Process.color = orange
local OArr = fn_GetObjs()
local toChVal = spnr_ToChannel.value
if OArr.count != 0 then
(
resetXForm OArr; ConvertTo OArr Editable_Poly
if chbtn_WeldInProcess.checked then (fn_Weld OArr spnr_WeldThresholdInProcess.value)
fn_toEMtoEPnoSubSel OArr
max modify mode
if chbtn_ChToCh.checked then
(
if rdbtn_ByObjMat.state == 1
then
	(
	for objct in OArr do
		(
		if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages()
		ChannelInfo.CopyChannel objct 3 1; ChannelInfo.PasteChannel objct 3 toChVal
		local unvr = Unwrap_UVW (); unvr.setMapChannel toChVal; unvr.setTVSubObjectMode 0; addmodifier objct unvr
		if chbtn_Pack.checked then
			(
			select objct
			$.modifiers[#unwrap_uvw].SetPackRescaleCluster (chbtn_RescaleClusters.checked)
			$.modifiers[#unwrap_uvw].pack ((ddl_Algorithm.selection)-1) (spnr_Padding.value) (chbtn_NormalizeClstrs.checked) (chbtn_RotateClstrs.checked) (chbtn_FillHoles.checked)
			subobjectLevel = 0
			)
		prgrs_Process.value = 100.0*(findItem OArr objct)/(OArr.count)
		)
	if chbtn_PivotCenter.checked then (for objct in OArr do (objct.pivot = objct.center))
	if chbtn_PivotZmin.checked then (for objct in OArr do (objct.pivot.Z = objct.min.Z))
	select OArr
	prgrs_Process.color = green
	)
else
	(
	local matArr = #(); for objct in OArr where (objct.material != undefined) do (appendIfUnique matArr objct.material)
	local objByMatArr = #(); local tArr = #(); for mat in matArr do (for objct in OArr where objct.material == mat do (appendIfUnique tArr objct); qSort tArr fn_compareNames; append objByMatArr tArr; tArr = #())
	local newObjArr = #()
	for mArr in objByMatArr do (if mArr.count > 1 then (local no = fn_Attach mArr; print (no.name); append newObjArr no) else (append newObjArr mArr[1]))
	resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
	for newObj in newObjArr do
		(
		if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages()
		ChannelInfo.CopyChannel newObj 3 1; ChannelInfo.PasteChannel newObj 3 toChVal
		local unvr = Unwrap_UVW (); unvr.setMapChannel toChVal; unvr.setTVSubObjectMode 0; addmodifier newObj unvr
		if chbtn_Pack.checked then
			(
			select newObj
			$.modifiers[#unwrap_uvw].SetPackRescaleCluster (chbtn_RescaleClusters.checked)
			$.modifiers[#unwrap_uvw].pack ((ddl_Algorithm.selection)-1) (spnr_Padding.value) (chbtn_NormalizeClstrs.checked) (chbtn_RotateClstrs.checked) (chbtn_FillHoles.checked)
			subobjectLevel = 0
			)
		prgrs_Process.value = 100.0*(findItem newObjArr newObj)/(newObjArr.count)
		)
	if chbtn_PivotCenter.checked then (for objct in newObjArr do (objct.pivot = objct.center))
	if chbtn_PivotZmin.checked then (for objct in newObjArr do (objct.pivot.Z = objct.min.Z))
	select newObjArr
	prgrs_Process.color = green
	)
local ObjctsArr = selection as array
if chbtn_AttachColorState.checked then (for objct in ObjctsArr do (objct.wirecolor = color_AttachWireColor.color))
if chbtn_ResetXForm.checked then (ConvertTo ObjctsArr Editable_Mesh; resetXForm ObjctsArr; ConvertTo ObjctsArr Editable_Poly)
)
) else (fn_Warning1())
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Process rightclick do
with undo on
(
max create mode
prgrs_Process.value = 0
prgrs_Process.color = orange
local OArr = fn_GetObjs()
local toChVal = spnr_ToChannel.value
if OArr.count != 0 then
(
resetXForm OArr; ConvertTo OArr Editable_Poly
if chbtn_WeldInProcess.checked then (fn_Weld OArr spnr_WeldThresholdInProcess.value)
fn_toEMtoEPnoSubSel OArr
max modify mode
if chbtn_ChToCh.checked then
(
if rdbtn_ByObjMat.state == 1
then
	(
	for objct in OArr do
		(
		if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages()
		ChannelInfo.CopyChannel objct 3 1; ChannelInfo.PasteChannel objct 3 toChVal
		local unvr = Unwrap_UVW (); unvr.setMapChannel toChVal; unvr.setTVSubObjectMode 0; addmodifier objct unvr
		if chbtn_Pack.checked then
			(
			select objct
			$.modifiers[#unwrap_uvw].SetPackRescaleCluster (chbtn_RescaleClusters.checked)
			$.modifiers[#unwrap_uvw].pack ((ddl_Algorithm.selection)-1) (spnr_Padding.value) (chbtn_NormalizeClstrs.checked) (chbtn_RotateClstrs.checked) (chbtn_FillHoles.checked)
			subobjectLevel = 0
			)
		prgrs_Process.value = 100.0*(findItem OArr objct)/(OArr.count)
		)
	if chbtn_PivotCenter.checked then (for objct in OArr do (objct.pivot = objct.center))
	if chbtn_PivotZmin.checked then (for objct in OArr do (objct.pivot.Z = objct.min.Z))
	select OArr
	prgrs_Process.color = green
	)
else
	(
	local matArr = #(); for objct in OArr where (objct.material != undefined) do (appendIfUnique matArr objct.material)
	local objByMatArr = #(); local tArr = #(); for mat in matArr do (for objct in OArr where objct.material == mat do (appendIfUnique tArr objct); qSort tArr fn_compareNames; append objByMatArr tArr; tArr = #())
	local newObjArr = #()
	for mArr in objByMatArr do (if mArr.count > 1 then (local no = fn_Attach mArr; print (no.name); append newObjArr no) else (append newObjArr mArr[1]))
	resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
	for newObj in newObjArr do
		(
		if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages()
		ChannelInfo.CopyChannel newObj 3 1; ChannelInfo.PasteChannel newObj 3 toChVal
		local unvr = Unwrap_UVW (); unvr.setMapChannel toChVal; unvr.setTVSubObjectMode 0; addmodifier newObj unvr
		if chbtn_Pack.checked then
			(
			select newObj
			$.modifiers[#unwrap_uvw].SetPackRescaleCluster (chbtn_RescaleClusters.checked)
			$.modifiers[#unwrap_uvw].pack ((ddl_Algorithm.selection)-1) (spnr_Padding.value) (chbtn_NormalizeClstrs.checked) (chbtn_RotateClstrs.checked) (chbtn_FillHoles.checked)
			subobjectLevel = 0
			)
		prgrs_Process.value = 100.0*(findItem newObjArr newObj)/(newObjArr.count)
		)
	if chbtn_PivotCenter.checked then (for objct in newObjArr do (objct.pivot = objct.center))
	if chbtn_PivotZmin.checked then (for objct in newObjArr do (objct.pivot.Z = objct.min.Z))
	select newObjArr
	prgrs_Process.color = green
	)
local ObjctsArr = selection as array
if chbtn_AttachColorState.checked then (for objct in ObjctsArr do (objct.wirecolor = color_AttachWireColor.color))
if chbtn_ResetXForm.checked
then (ConvertTo ObjctsArr Editable_Mesh; resetXForm ObjctsArr; ConvertTo ObjctsArr Editable_Poly)
else (ObjctsArr[1].modifiers[#unwrap_uvw].edit())
)
) else (fn_Warning1())
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_ResetXForm pressed do 
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
fn_toEMtoEPnoSubSel OArr; resetXForm OArr; ConvertTo OArr Editable_Poly
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_ConvertToEP pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
fn_toEMtoEPnoSubSel OArr
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddNormal pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
fn_toEMtoEPnoSubSel OArr
max modify mode
undo on
modPanel.addModToSelection (normalModifier flip:true)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddNormal rightclick do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
fn_toEMtoEPnoSubSel OArr
for objct in OArr do (addModifier objct (normalModifier flip:true))
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_FlipNormals pressed do
(
if Filters.Is_EPolySpecifyLevel #{5,6} and (PolyBGetSel 3).count!=0 then
	(
	macros.run "Editable Polygon Object" "EPoly_Flip"
-- 	subobjectLevel = 0
	)
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_FlipNormals rightclick do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
max create mode
undo on
fn_toEMtoEPnoSubSel OArr; resetXForm OArr; ConvertTo OArr Editable_Poly; fn_SmartFlipNormal OArr
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Weld pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
max create mode
undo on
resetXForm OArr; ConvertTo OArr Editable_Poly; fn_Weld OArr spnr_WeldThreshold.value; fn_toEMtoEPnoSubSel OArr
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelInstances pressed do
(
tempArr = allInstArr = selection as array
exclud = #(0)
for i=1 to tempArr.count do 
	(
	if findItem exclud i != 0 do continue
	InstanceMgr.GetInstances tempArr[i] &instances
	for j in instances do 
		(
		k = findItem tempArr j
		if k != 0 do 
			(
			appendIfUnique exclud k
			continue
		    )
		if findItem allInstArr j != 0 do continue
		if j.isHiddenInVpt==false do allInstArr = allInstArr + j
	    )
	)
undo on
select allInstArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_MakeUnique pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
InstanceMgr.MakeObjectsUnique OArr #individual
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Quadrify pressed do
(
max modify mode
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
ConvertTo OArr Editable_Poly
undo on
for objct in OArr do (with undo off (select objct); macros.run "PolyTools" "Quadrify")
select OArr
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByMaterial pressed do
(
local matArr = #(); matArr = for selObj in selection where (selObj.material != undefined) collect selObj.material
local objArr = #(); for objct in objects where not objct.isHidden do (for mat in matArr where objct.material == mat do (appendIfUnique objArr objct))
undo on
select objArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByMaterial rightclick do
(
local matArr = #(); matArr = for selObj in selection where (selObj.material != undefined) collect selObj.material
local objArr = #(); for objct in objects do (for mat in matArr where objct.material == mat do (appendIfUnique objArr objct))
undo on
select objArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByWire pressed do
(
local WColArr = #(); local WColObjArr = #()
for sobj in selection do (appendIfUnique WColArr sobj.wirecolor)
for objct in objects where not objct.isHidden do (for wc in WColArr where objct.wirecolor == wc do (appendIfUnique WColObjArr objct))
undo on
select WColObjArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByWire rightclick do
(
local WColArr = #(); local WColObjArr = #()
for sobj in selection do (appendIfUnique WColArr sobj.wirecolor)
for objct in objects do (for wc in WColArr where objct.wirecolor == wc do (appendIfUnique WColObjArr objct))
undo on
select WColObjArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByMultiSub pressed do
(
local MultiSubMatArr = #(); local MultiSubObjArr = #()
-- for objct in selection where classOf objct.material == Multimaterial do (appendIfUnique MultiSubMatArr objct.material)
MultiSubMatArr = getclassinstances Multimaterial
for objct in objects where not objct.isHidden do (for sm in MultiSubMatArr where objct.material == sm do (appendIfUnique MultiSubObjArr objct))
undo on
select MultiSubObjArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SelByMultiSub rightclick do
(
local MultiSubMatArr = #(); local MultiSubObjArr = #()
-- for objct in selection where classOf objct.material == Multimaterial do (appendIfUnique MultiSubMatArr objct.material)
MultiSubMatArr = getclassinstances Multimaterial
for objct in objects do (for sm in MultiSubMatArr where objct.material == sm do (appendIfUnique MultiSubObjArr objct))
undo on
select MultiSubObjArr
forceCompleteRedraw()
max modify mode
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Attach pressed do
with undo on
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct; qsort OArr fn_compareNames
if OArr.count != 0 then
(
max create mode; explodeGroup selection
local prts = spnr_AttachParts.value
local newObjArr =#()
fn_toEMtoEPnoSubSel OArr; resetXForm OArr; ConvertTo OArr Editable_Poly
if OArr.count != 0 then
(
if prts == 1
then (append newObjArr (fn_Attach OArr))
else
	(
	if ((OArr.count)/(prts as float)) >= 1
	then
		(
		local partsArr = #(); local t1Arr = #()
		for p=1 to prts do (for o=p to OArr.count by prts do (append t1Arr OArr[o]); append partsArr t1Arr; t1Arr = #())
		for prtObjs in partsArr do (append newObjArr (fn_Attach prtObjs))
		)
	else (append newObjArr (fn_Attach OArr))
	)
)
for objct in newObjArr do (objct.pivot = objct.center)
if chbtn_AttachColorState.checked then (for objct in newObjArr do (objct.wirecolor = color_AttachWireColor.color))
resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
max modify mode
) else (fn_Warning2())
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Attach rightclick do
with undo on
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct; qsort OArr fn_compareNames
local matArr = #(); for objct in OArr where (objct.material != undefined) do (appendIfUnique matArr objct.material)
local objByMatArr = #(); local tArr = #(); for mat in matArr do (for objct in OArr where objct.material == mat do (appendIfUnique tArr objct); qSort tArr fn_compareNames; append objByMatArr tArr; tArr = #())
if matArr.count != 0 then
(
max create mode; explodeGroup selection
local newObjArr =#()
for ObyM in objByMatArr do
	(
	fn_toEMtoEPnoSubSel ObyM; resetXForm ObyM; ConvertTo ObyM Editable_Poly
	append newObjArr (fn_Attach ObyM)
	)
for objct in newObjArr do (objct.pivot = objct.center)
if chbtn_AttachColorState.checked then (for objct in newObjArr do (objct.wirecolor = color_AttachWireColor.color))
resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
max modify mode
) else (messageBox "Objects are not Selected or have not Material." title:" WARNING !!!" beep:false)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Detach pressed do
(
if Filters.Is_EPolySpecifyLevel #{5,6} and (PolyBGetSel 3).count!=0 then
	(
	local objName = fn_RemoveCounter ($.name)
	local fSel = polyop.getFaceSelection $
	if (fSel as array).count != 0 then
		(
		local newName = uniqueName "ldkfdflsds" numDigits:9
		polyOp.detachFaces $ fSel asNode:true name:newName
		local newObj = getnodebyname newName
		fn_RenameAddCounter objName #(newObj) "_" 3
		newObj.SetSelection #Face #{}
		newObj.pivot = newObj.center
		subobjectLevel = 0
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Detach rightclick do
(
if Filters.Is_EPolySpecifyLevel #{5,6} and (PolyBGetSel 3).count!=0 then
	(
	macros.run "Editable Polygon Object" "EPoly_Detach"
	subobjectLevel = 0
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Explode pressed do
with undo on
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject) and (IsValidNode objct)) collect objct; qsort OArr fn_compareNames
if OArr.count != 0 then
(
max create mode; explodeGroup selection
local oldIsoArr = #(); local newIsoArr = #(); local IsoActive = IsolateSelection.IsolateSelectionModeActive(); local vTM; local vFDist
if IsoActive then (for objct in objects where (IsolateSelection.IsNodeIsolated objct) do (append oldIsoArr objct); newIsoArr = fn_ArraysDifference oldIsoArr OArr; vTM = viewport.getTM(); vFDist = viewport.getFocalDistance())
local newObjArr = #()
fn_toEMtoEPnoSubSel OArr; resetXForm OArr; ConvertTo OArr Editable_Poly
for objct in OArr do
	(
	local prts = spnr_ExplodeParts.value
	local objName = fn_RemoveCounter (objct.name)
	local tArr = #()
	if prts == 0
	then
		(
		while polyOp.getNumFaces objct != 0 do 
			(
			local tName = uniqueName "ldkfdflsds" numDigits:9
			local f_list = polyOp.getElementsUsingFace objct #{1}
			local elem = polyOp.detachFaces objct f_list asNode:true name:tName
			append tArr (getnodebyname tName)
			)
		)
	else
		(
		while polyOp.getNumFaces objct != 0 do 
			(
			local tName = uniqueName "ldkfdflsds" numDigits:9
			local elementsArr=#(); local facesDoneArr=#(); local facesArr=#()
			for fi=1 to objct.numfaces do (if (finditem facesDoneArr fi) == 0 then (facesArr = polyop.getElementsUsingFace objct #(fi); append elementsArr facesArr; join facesDoneArr facesArr))
			local elPart = #{}
			for nel=1 to elementsArr.count by prts do (join elPart elementsArr[nel])
			polyOp.detachFaces objct elPart asNode:true name:tName
			append tArr (getnodebyname tName)
			prts -= 1
			)
		)
	delete objct
	fn_RenameAddCounter objName tArr "_" 3
	join newObjArr tArr
	)
for objct in newObjArr do (objct.pivot = objct.center)
ConvertTo newObjArr Editable_Mesh; resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
join newIsoArr newObjArr; if IsoActive then (select newIsoArr; IsolateSelection.EnterIsolateSelectionMode(); if viewport.getType() == #view_persp_user then (viewport.setTM vTM; viewport.setFocalDistance vFDist))
select newObjArr
if keyboard.altPressed
then
	(
	theObj = dotNetObject "MaxCustomControls.RenameInstanceDialog" ""; theobj.text = "Rename Objects"; DialogResult = theObj.Showmodal()
	if (dotnet.compareenums TheObj.DialogResult ((dotnetclass "System.Windows.Forms.DialogResult").OK)) then (NewStringEntered = theobj.InstanceName)
	if NewStringEntered != undefined then (fn_RenameAddCounter NewStringEntered newObjArr "_" 3)
	)
max modify mode
) else (fn_Warning2())
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Explode rightclick do
with undo on
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject) and (IsValidNode objct)) collect objct; qsort OArr fn_compareNames
local MultimatArr = for objct in OArr where (classOf objct.material == Multimaterial) collect objct
if MultimatArr.count != 0 then
(
max create mode; explodeGroup selection
local oldIsoArr = #(); local newIsoArr = #(); local IsoActive = IsolateSelection.IsolateSelectionModeActive(); local vTM; local vFDist
if IsoActive then (for objct in objects where (IsolateSelection.IsNodeIsolated objct) do (append oldIsoArr objct); newIsoArr = fn_ArraysDifference oldIsoArr OArr; vTM = viewport.getTM(); vFDist = viewport.getFocalDistance())
local newObjArr = #()
for objct in MultimatArr do
	(
	resetXForm objct; ConvertTo objct Editable_Poly
	local objName = fn_RemoveCounter (objct.name)
	local tArr = #()
	local oMat = objct.material
	local idList = #()
	for i in 1 to (getnumfaces objct) do (fID = objct.getfacematerial i; if not (finditem idList fID) != 0 then append idList fID)
	for id in idList do
		(
		local tName = uniqueName "ldkfdflsds" numDigits:9
		objct.selectbymaterial id; local fList = getfaceselection objct; objct.SetSelection #Face #{}
		polyOp.detachFaces objct fList asnode:true name:tName
		newObjct = getnodebyname tName
		newObjct.material = oMat[id]
		append tArr newObjct
		)
	delete objct
	fn_RenameAddCounter objName tArr "_" 3
	join newObjArr tArr
	)
for objct in newObjArr do (objct.pivot = objct.center)
ConvertTo newObjArr Editable_Mesh; resetXForm newObjArr; ConvertTo newObjArr Editable_Poly
join newIsoArr newObjArr; if IsoActive then (select newIsoArr; IsolateSelection.EnterIsolateSelectionMode(); if viewport.getType() == #view_persp_user then (viewport.setTM vTM; viewport.setFocalDistance vFDist))
select newObjArr
if keyboard.altPressed
then
	(
	theObj = dotNetObject "MaxCustomControls.RenameInstanceDialog" ""; theobj.text = "Rename Objects"; DialogResult = theObj.Showmodal()
	if (dotnet.compareenums TheObj.DialogResult ((dotnetclass "System.Windows.Forms.DialogResult").OK)) then (NewStringEntered = theobj.InstanceName)
	if NewStringEntered != undefined then (fn_RenameAddCounter NewStringEntered newObjArr "_" 3)
	)
max modify mode
) else (fn_Warning2())
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_SetWireColor pressed do (undo on; for objct in selection do (objct.wirecolor = color_SetWireColor.color))
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_PivotToCenter pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
for objct in OArr do (objct.pivot = objct.center)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_PivotToZmin pressed do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
undo on
for objct in OArr do (objct.pivot.Z = objct.min.Z)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddUnwrapUVW pressed do
with undo on
(
max modify mode
if selection.count == 1 do
	(
	local toChVal = spnr_AddUnwrapChannel.value
	local unvr = Unwrap_UVW ()
	unvr.setMapChannel toChVal
	addmodifier $ unvr
-- 	unvr.Reset()
	subobjectLevel = 0
-- 	unvr.edit()
-- 	unvr.setTVSubObjectMode 3
-- 	unvr.setTVElementMode true
-- 	unvr.unwrap6.selectFacesByNode #{} $
-- 	unvr.unwrap2.setFreeFormMode on
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddUnwrapUVW rightclick do
with undo on
(
max modify mode
if selection.count == 1 do
	(
	local toChVal = spnr_AddUnwrapChannel.value
-- 	if SuperclassOf (modPanel.getCurrentObject()) == GeometryClass
	if (ClassOf (modPanel.getCurrentObject())) == Unwrap_UVW
	then
		(
		local unvr = modPanel.getCurrentObject()
		local getCh; if unvr.getMapChannel() == 0 then (getCh = 1) else (getCh = unvr.getMapChannel())
		if getCh != toChVal then (unvr.setMapChannel toChVal; unvr.Reset())
		unvr.edit()
		subobjectLevel = 0
-- 		unvr.setTVSubObjectMode 3
-- 		unvr.setTVElementMode true
-- 		unvr.unwrap6.selectFacesByNode #{} $
-- 		unvr.unwrap2.setFreeFormMode on
		)
	else
		(
		local unvr = Unwrap_UVW ()
		unvr.setMapChannel toChVal
		addmodifier $ unvr
		unvr.edit()
		subobjectLevel = 0
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_UnwrapUVWCheck pressed do
with undo on
(
max modify mode
if selection.count == 1 do
	(
	local toChVal = spnr_AddUnwrapChannel.value
-- 	local toChVal = (if spnr_AddUnwrapChannel.value == 1 then 0 else spnr_AddUnwrapChannel.value)
		print toChVal
	local unvr = Unwrap_UVW ()
	unvr.setMapChannel toChVal
	unvr.name = "Unwrap UVW Check"
	addmodifier $ unvr
	unvr.edit()
	subobjectLevel = 0
-- 	unvr.setTVSubObjectMode 3
-- 	unvr.setTVElementMode true
-- 	unvr.unwrap6.selectFacesByNode #{} $
-- 	unvr.unwrap2.setFreeFormMode on
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_UnwrapUVWCheck rightclick do
with undo on
(
max modify mode
if selection.count == 1 do
	(
	local ModifiersInStackCount = (for m in $.modifiers collect m).count
	if ModifiersInStackCount > 0
	then
		(
-- 		if (ClassOf (modPanel.getCurrentObject())) == Unwrap_UVW
		local theModsArr = for mdfr in $.modifiers where (mdfr.name == "Unwrap UVW Check") collect mdfr
		for m in theModsArr do deleteModifier $ m
-- 		local unvr = Unwrap_UVW (); unvr.setMapChannel toChVal; addmodifier $ unvr
-- 		unvr.edit()
-- 		unvr.setTVSubObjectMode 3
-- 		unvr.setTVElementMode true
-- 		unvr.unwrap6.selectFacesByNode #{} $
-- 		unvr.unwrap2.setFreeFormMode on
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_FlattenMapping pressed do
with undo on
(
max modify mode
if selection.count == 1 do
	(
-- 	local toChVal = spnr_AddUnwrapChannel.value
	if (ClassOf (modPanel.getCurrentObject())) == Unwrap_UVW
	then
		(
		local unvr = modPanel.getCurrentObject()
		unvr.edit()
		subobjectLevel = 0
		unvr.flattenMap (spnr_FlattenAngleThreshold.value) #([1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]) (spnr_FlattenSpacing.value) true 0 true true
		)
	else
		(
		local unvr = Unwrap_UVW ()
-- 		unvr.setMapChannel toChVal
		addmodifier $ unvr
		unvr.edit()
		subobjectLevel = 0
		unvr.flattenMap (spnr_FlattenAngleThreshold.value) #([1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]) (spnr_FlattenSpacing.value) true 0 true true
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddUVWMap pressed do (max modify mode; local MapSize = spnr_UVWMapSize.value; modPanel.addModToSelection (UVWMap maptype:4 length:MapSize width:MapSize height:MapSize) )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddUVWMap rightclick do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
local trimArr = fn_InstancesTrim OArr
undo on
local MapSize = spnr_UVWMapSize.value
for objct in trimArr do (addModifier objct (UVWMap maptype:4 length:MapSize width:MapSize height:MapSize) )
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddSmooth pressed do (max modify mode; modPanel.addModToSelection (Smooth autosmooth:on) )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddSmooth rightclick do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
local trimArr = fn_InstancesTrim OArr
undo on
for objct in trimArr do (addModifier objct (Smooth autosmooth:on) )
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddEditPoly pressed do (max modify mode; modPanel.addModToSelection (Edit_Poly()) )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddEditPoly rightclick do
(
local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
local trimArr = fn_InstancesTrim OArr
undo on
for objct in trimArr do (addModifier objct (Edit_Poly()) )
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddTurboSmooth pressed do (max modify mode; modPanel.addModToSelection (TurboSmooth()) )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_AddTurboSmooth rightclick do (max modify mode; modPanel.addModToSelection (TurboSmooth sepBySmGroups:on) )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_ExportFBX pressed do
(
if selection.count != 0 then
	(
	local lastUsedDir = fn_GetINIExecuteStr iniFile "General" "LastUsedExportDir" ""
	if lastUsedDir.count == 3 then ( for w = 1 to lastUsedDir.count do (if lastUsedDir[w] == "/" then (lastUsedDir = replace lastUsedDir w 1 "")) )
	if lastUsedDir[lastUsedDir.count] == "\\" then (lastUsedDir = replace lastUsedDir lastUsedDir.count 1 "")
	local SaveInFile = getSaveFileName caption:"Export FBX..." filename:(lastUsedDir + "\\") types:"Autodesk (*.FBX)|*.FBX|All|*.*|"
	if SaveInFile != undefined then
		(
		exportFile SaveInFile #noprompt selectedOnly:true using:FbxExp
		setINISetting iniFile "General" "LastUsedExportDir" (getFilenamePath SaveInFile)
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_ExportFBX rightclick do
(
if selection.count != 0 then
	(
	local lastUsedDir = fn_GetINIExecuteStr iniFile "General" "LastUsedExportDir" ""
	if lastUsedDir.count == 3 then ( for w = 1 to lastUsedDir.count do (if lastUsedDir[w] == "/" then (lastUsedDir = replace lastUsedDir w 1 "")) )
	if lastUsedDir[lastUsedDir.count] == "\\" then (lastUsedDir = replace lastUsedDir lastUsedDir.count 1 "")
	local SaveInFile = getSaveFileName caption:"Export FBX..." filename:(lastUsedDir + "\\") types:"Autodesk (*.FBX)|*.FBX|All|*.*|"
	if SaveInFile != undefined then
		(
		exportFile SaveInFile selectedOnly:true using:FbxExp
		setINISetting iniFile "General" "LastUsedExportDir" (getFilenamePath SaveInFile)
		)
	)
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_GroupGroup pressed do (if selection.count != 0 then (group $ name:(uniqueName ("Group_" + (fn_RemoveCounter selection[1].name) + "_") numDigits:3) select:true))
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_GroupGroup rightclick do (max group group)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_UngroupGroup pressed do (max group ungroup)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_UngroupGroup rightclick do (max group explode)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_OpenGroup pressed do (max group open)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_OpenGroup rightclick do (max group close)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on chbtn_RenameAddCounter changed state do (SetFocus rolloutUVPuppy)
on chbtn_RenameAddCounter rightclick do (colCHBX = fn_setCHBXcol CHBXarr)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_GetName pressed do
(
-- local OArr = for objct in selection where (not(SuperClassOf objct == helper)) collect objct
local OArr = for objct in selection where (not(isGroupHead objct)) collect objct
local GHArr = for objct in selection where (isGroupHead objct) collect objct
if GHArr.count != 0
then (edt_NewName.text = (fn_RemoveCounter (GHArr[1].name)))
else (if OArr.count != 0 then (edt_NewName.text = (fn_RemoveCounter (OArr[1].name))))
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_GetName rightclick do (try (edt_NewName.text = selection[1].material.name) catch())
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Rename pressed do
with undo on
(
local OArr = for objct in selection where (not(SuperClassOf objct == helper)) collect objct
if chbtn_RenameAddCounter.checked
then (fn_RenameAddCounter (edt_NewName.text) OArr "_" 3)
else (OArr.name = edt_NewName.text)
local dum = Dummy(); delete dum
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
on btn_Rename rightclick do
with undo on
(
local OArr = for objct in selection where (not(SuperClassOf objct == helper)) collect objct
local matArr = #(); for objct in OArr where (objct.material != undefined) do (appendIfUnique matArr objct.material)
local objByMatArr = #(); local tArr = #(); for mat in matArr do (for objct in OArr where objct.material == mat do (appendIfUnique tArr objct); qSort tArr fn_compareNames; append objByMatArr tArr; tArr = #())
-- for mArr in objByMatArr do (fn_RenameAddCounter (fn_RemoveCounter (mArr[1].name)) mArr "" 3)
for mArr in objByMatArr do (fn_RenameAddCounter (fn_RemoveCounter (mArr[1].name)) mArr "_" 3)
local dum = Dummy(); delete dum
)
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-- on btn_SmoothingGroupsByUV pressed do
-- with undo on
-- (
-- max modify mode
-- local OArr = for objct in selection where ((SuperClassOf objct == GeometryClass) and not(ClassOf objct == Targetobject)) collect objct
-- for objct in OArr do
-- 	(
-- 	select objct
-- 	local obj = selection[1]
-- 	local uv = modPanel.getCurrentObject()
-- 	if (classof (uv) != Unwrap_UVW) then (modPanel.addModToSelection (Unwrap_UVW ()) ui:on; uv = modPanel.getCurrentObject())
-- 	uv.unwrap2.setTVSubObjectMode(3)
-- 	local totalFaces = uv.unwrap.numberPolygons()
-- 	local faceElemArray = #()
-- 	for f=1 to totalFaces do (faceElemArray[ f ] = 0)
-- 	local elem = #()
-- 	for f=1 to totalFaces do
-- 		(
-- 		if faceElemArray[ f ] == 0 then
-- 			(
-- 			uv.unwrap2.selectFaces #{ f }; uv.unwrap2.selectElement()
-- 			local elemFaces = uv.unwrap2.getSelectedFaces() as array; append elem (uv.unwrap2.getSelectedFaces())
-- 			for i in elemFaces do (faceElemArray[ i ] = elem.count)
-- 			)
-- 		)
-- 	deletemodifier obj uv
-- 	modPanel.addModToSelection (Edit_Poly ()) ui:on
-- 	obj.modifiers[#Edit_Poly].autoSmoothThreshold = 180	
-- 	for el in elem do (obj.modifiers[#Edit_Poly].SetSelection #Face el; obj.modifiers[#Edit_Poly].ButtonOp #Autosmooth)
-- 	)
-- )
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-- on btn_WeightedNormals pressed do
-- with undo on
-- (
-- fn GenWeightedNormals obj =
-- (
-- if (superClassOf obj) != GeometryClass do return false
-- if (classOf obj) != Editable_Mesh do (addModifier obj (Edit_Mesh()))
-- local mf; for i=1 to obj.modifiers.count do (local mf = obj.modifiers[i]; if (classof mf) == Edit_Normals do (if (mf.name == "Weighted Normals") then (mf = mf) else (mf = undefined)))
-- if mf == undefined do (addModifier obj (Edit_Normals()); mf = obj.modifiers[#Edit_Normals]; mf.name = "Weighted Normals")
-- select obj
-- max modify mode
-- local facearea = #()
-- facearea.count = obj.numFaces
-- for i=1 to obj.numFaces do (facearea[i] = (meshop.getFaceArea obj i))
-- local faceangle = #()
-- faceangle.count = obj.numFaces
-- for i=1 to obj.numFaces do
-- 	(
-- 	local f = getFace obj i
-- 	local v1 = getVert obj f[1]; local v2 = getVert obj f[2]; local v3 = getVert obj f[3]
-- 	local a1 = (acos (dot (normalize (v2-v1)) (normalize (v3-v1))))
-- 	local a2 = (acos (dot (normalize (v1-v2)) (normalize (v3-v2))))
-- 	local a3 = (acos (dot (normalize (v1-v3)) (normalize (v2-v3))))
-- 	faceangle[i] = [a1,a2,a3]
-- 	)
-- local normNum = mf.GetNumNormals()
-- local norms = #()
-- norms.count = normNum
-- for i=1 to normNum do (norms[i] = [0,0,0])
-- for i=1 to obj.numFaces do
-- 	(
-- 	in coordsys local n = getFaceNormal obj i
-- 	for j=1 to 3 do (local id = mf.GetNormalID i j; norms[id] = norms[id] + (n * facearea[i] * faceangle[i][j]))
-- 	)
-- for i=1 to normNum do (mf.SetNormalExplicit i explicit:true; mf.SetNormal i (normalize norms[i]))
-- )
-- local sel = #()
-- for i=1 to selection.count do (sel[i] = selection[i])
-- for i=1 to sel.count do (GenWeightedNormals sel[i])
-- selection = sel
-- )
--OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
----=====================================================================
on rolloutUVPuppy open do
	(
	local DockState = (fn_GetINIExecuteStr iniFile "DialogPosition" "DockState" "undefined")
	if DockState != "undefined"
	then
		(
-- 		rolloutUVPuppy.height = roll0minH-2; btn_MinimizeUI.caption = "+"
		cui.RegisterDialogBar rolloutUVPuppy style:#(#cui_dock_horz)
		if DockState == "cui_dock_left" then (cui.DockDialogBar rolloutUVPuppy #cui_dock_left) else (cui.DockDialogBar rolloutUVPuppy #cui_dock_right)
		)
	fn_updateCHBXcol CHBXarr
	)
-------------------------------------------------------------------------------------------------------------
on rolloutUVPuppy close do 
	(
	try (setINISetting iniFile "DialogPosition" "LastPosition" ((GetDialogPos rolloutUVPuppy) as string)) catch()
	setINISetting iniFile "General" "InputArray" (rdbtn_FromObjcts.state as string)
	setINISetting iniFile "General" "WeldInProcess" (chbtn_WeldInProcess.checked as string)
	setINISetting iniFile "General" "WeldThresholdInProcess" (spnr_WeldThresholdInProcess.value as string)
	setINISetting iniFile "General" "ChanelToChanel" (chbtn_ChToCh.checked as string)
	setINISetting iniFile "General" "ToChannel" (spnr_ToChannel.value as string)
	setINISetting iniFile "General" "ProcessBy" (rdbtn_ByObjMat.state as string)
	setINISetting iniFile "General" "Pack" (chbtn_Pack.checked as string)
	setINISetting iniFile "PackSettings" "Algorithm" (ddl_Algorithm.selection as string)
	setINISetting iniFile "PackSettings" "Padding" (spnr_Padding.value as string)
	setINISetting iniFile "PackSettings" "NormalizeClusters" (chbtn_NormalizeClstrs.checked as string)
	setINISetting iniFile "PackSettings" "RotateClusters" (chbtn_RotateClstrs.checked as string)
	setINISetting iniFile "PackSettings" "FillHoles" (chbtn_FillHoles.checked as string)
	setINISetting iniFile "PackSettings" "RescaleClusters" (chbtn_RescaleClusters.checked as string)
	setINISetting iniFile "General" "PivotToCenter" (chbtn_PivotCenter.checked as string)
	setINISetting iniFile "General" "PivotToZmin" (chbtn_PivotZmin.checked as string)
	setINISetting iniFile "General" "ResetXForm" (chbtn_ResetXForm.checked as string)
	setINISetting iniFile "General" "AttachColorState" (chbtn_AttachColorState.checked as string)
	setINISetting iniFile "General" "AttachWireColor" (color_AttachWireColor.color as string)
	setINISetting iniFile "General" "AddUnwrapChannel" (spnr_AddUnwrapChannel.value as string)
	setINISetting iniFile "General" "WeldThreshold" (spnr_WeldThreshold.value as string)
	setINISetting iniFile "General" "AttachParts" (spnr_AttachParts.value as string)
	setINISetting iniFile "General" "ExplodeParts" (spnr_ExplodeParts.value as string)
	setINISetting iniFile "General" "SetWireColor" (color_SetWireColor.color as string)
	setINISetting iniFile "General" "FlattenAngleThreshold" (spnr_FlattenAngleThreshold.value as string)
	setINISetting iniFile "General" "FlattenSpacing" (spnr_FlattenSpacing.value as string)
	setINISetting iniFile "General" "UVWMapSize" (spnr_UVWMapSize.value as string)
	setINISetting iniFile "General" "RenameAddCounter" (chbtn_RenameAddCounter.checked as string)
	setINISetting iniFile "General" "CheckboxColor" (colCHBX as string)
	rolloutUVPuppy = undefined
	)
)
----=====================================================================
on execute do
	(
	DialogPosition = fn_GetINIExecute iniFile "DialogPosition" "LastPosition" [5,30]
	if DialogPosition[1] < 0 then DialogPosition[1] = 0; if DialogPosition[2] < 30 then DialogPosition[2] = 30
	if (DialogPosition[1] > (sysInfo.DesktopSize[1] - roll0W)) then abs(DialogPosition[1] = (sysInfo.DesktopSize[1] - roll0W - 10))
	if (DialogPosition[2] > (sysInfo.DesktopSize[2] - roll0H)) then abs(DialogPosition[2] = (sysInfo.DesktopSize[2] - roll0H - 30))
-- 	CreateDialog rolloutUVPuppy roll0W roll0H pos:DialogPosition style:#(#style_titlebar, #style_toolwindow, #style_sysmenu)
	CreateDialog rolloutUVPuppy roll0W roll0H pos:DialogPosition style:#(#style_titlebar,#style_sysmenu,#style_minimizebox)
	)
)